GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})

local _ctor = GLOBAL.Action._ctor
GLOBAL.Action._ctor = function(self, data, ...)
	if type(data) ~= "table" then data = {} end 
	return _ctor(self, data, ...)
end

Assets =
{
	Asset("IMAGE", "images/invimages/giftimgs.tex"),
	Asset("ATLAS", "images/invimages/giftimgs.xml"),
	Asset("ATLAS_BUILD", "images/invimages/giftimgs.xml", 256),

	Asset("SOUNDPACKAGE", "sound/gift_rain.fev" ),
	Asset("SOUND", "sound/gift_rain.fsb" ),
}

RegisterInventoryItemAtlas("images/invimages/giftimgs.xml", "gift_large1.tex")
RegisterInventoryItemAtlas("images/invimages/giftimgs.xml", "gift_large2.tex")
RegisterInventoryItemAtlas("images/invimages/giftimgs.xml", "gift_medium1.tex")
RegisterInventoryItemAtlas("images/invimages/giftimgs.xml", "gift_medium2.tex")
RegisterInventoryItemAtlas("images/invimages/giftimgs.xml", "gift_small1.tex")
RegisterInventoryItemAtlas("images/invimages/giftimgs.xml", "gift_small2.tex")
RegisterInventoryItemAtlas("images/invimages/giftimgs.xml", "giftwrap.tex")

RemapSoundEvent("dontstarve/giftshower/naughty", "gift_rain/gift_rain/naughty")
RemapSoundEvent("dontstarve/giftshower/moderate", "gift_rain/gift_rain/moderate")
RemapSoundEvent("dontstarve/giftshower/nice", "gift_rain/gift_rain/nice")
--RemapSoundEvent("dontstarve/sled/bell", "gift_rain/gift_rain/bell")
RemapSoundEvent("dontstarve/sled/bell2", "gift_rain/gift_rain/bell2")
RemapSoundEvent("dontstarve/sled/laughter", "gift_rain/gift_rain/laughter")

PrefabFiles = 
{
	"giftbundle",
	"sled",
}

AddPrefabPostInit('forest', function(inst)
	inst:AddComponent("worldsettingstimer")
	inst:AddComponent("giftshowerspawner")
	inst:AddComponent("giftshowerloot")
end)

AddComponentPostInit("kramped", function(self)
	self.krampuscame = false
	self.krampuscametimetodecay = TUNING.KRAMPUS_CAME_DECAY_PERIOD

	local _MakeAKrampus = self.MakeAKrampus
	function self:MakeAKrampus()
		self.krampuscame = true
		self.krampuscametimetodecay = TUNING.KRAMPUS_CAME_DECAY_PERIOD
		_MakeAKrampus(self)
	end

	local _OnUpdate = self.OnUpdate
	function self:OnUpdate(dt)
		_OnUpdate(self, dt)
		if self.krampuscame == true then
			self.krampuscametimetodecay = self.krampuscametimetodecay - dt

			if self.krampuscametimetodecay < 0 then
				self.krampuscametimetodecay = TUNING.KRAMPUS_CAME_DECAY_PERIOD
				self.krampuscame = false
			end
		end
	end

	local _OnSave = self.OnSave
	function self:OnSave()
		local data = _OnSave(self) or {}

		if self.krampuscame then
			data.krampus_came = self.krampuscame
		end
		
		if self.krampuscametimetodecay then
			data.krampuscametimetodecay = self.krampuscametimetodecay
		end

		return data
	end

	local _OnLoad = self.OnLoad
	function self:OnLoad(data)
		_OnLoad(self, data)

		self.krampuscame = data.krampus_came or false
		self.krampuscametimetodecay = data.krampuscametimetodecay or 0
	end
	
	local _LongUpdate = self.LongUpdate
	function self:LongUpdate(dt)
		if _LongUpdate then
			_LongUpdate(self, dt)
		end

		self:OnUpdate(dt)
	end
end)

if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	local giftwrap = Recipe("giftwrap",{Ingredient("papyrus", 1), Ingredient("petals", 1)}, RECIPETABS.SURVIVAL, TECH.LOST, RECIPE_GAME_TYPE.COMMON, nil, nil, nil, 4)
	giftwrap.sortkey = GetRecipe("bundlewrap").sortkey + 0.1
else
	local giftwrap = Recipe("giftwrap",{Ingredient("papyrus", 1), Ingredient("petals", 1)}, RECIPETABS.SURVIVAL, TECH.LOST, nil, nil, nil, 4)
	giftwrap.sortkey = GetRecipe("bundlewrap").sortkey + 0.1
end

TUNING.GIFTSHOWER_RESPAWN_DELAY = TUNING.TOTAL_DAY_TIME * 10
TUNING.GIFTSHOWER_TURNED_WINTER_DELAY = TUNING.TOTAL_DAY_TIME * 4
TUNING.GIFTSHOWER_SPAWN_DELAY = TUNING.TOTAL_DAY_TIME * 1
TUNING.GIFTSHOWER_SPAWN_DELAY_VARIANCE = TUNING.TOTAL_DAY_TIME * 2
TUNING.KRAMPUS_CAME_DECAY_PERIOD = TUNING.TOTAL_DAY_TIME * 8

STRINGS.NAMES.GIFT = "Gift"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.GIFT = 
	{
		GENERIC = "Is that for me?",
		NICE = "I've been very good this year.",
		MODERATE = "I've been moderately nice this year.",
		NAUGHTY = "I've been very naughty this year.",
	}
STRINGS.CHARACTERS.WILLOW.DESCRIBE.GIFT = 
	{
		GENERIC = "It's for me right?!",
		NICE = "I hope all those times I restrained myself from setting things on fire payed off!",
		MODERATE = "I could've been nicer, but also naughtier.",
		NAUGHTY = "I couldn't help myself this year. I've been pretty bad.",
	}
STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.GIFT = 
	{
		GENERIC = "Is nice little present!",
		NICE = "Wolfgang is good strongman.",
		MODERATE = "Wolfgang did okay job at being good this year.",
		NAUGHTY = "Wolfgang has been naughty...",
	}
STRINGS.CHARACTERS.WENDY.DESCRIBE.GIFT = 
	{
		GENERIC = "The only gift I desire is a swift end...",
		NICE = "I've been nice.",
		MODERATE = "I've been moderate.",
		NAUGHTY = "I've been naughty.",
	}
STRINGS.CHARACTERS.WX78.DESCRIBE.GIFT = 
	{
		GENERIC = "FINALLY. SOMEONE HAS REALIZED MY NATURAL EMINENCE",
		NICE = "I HAVE BEEN FRIENDLY TO ALL FLESHLINGS",
		MODERATE = "I HAVE BEEN FRIENDLY TO MOST FLESHLINGS",
		NAUGHTY = "FLESHLINGS DO NOT DESERVE MY COMPASSION",
	}
STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.GIFT = 
	{
		GENERIC = "Oh goodness, how lovely!",
		NICE = "I have been quite kind this year.",
		MODERATE = "Oh, I do wish I had done some things different.",
		NAUGHTY = "I hope I've been forgiven for my naughty deeds.",
	}
STRINGS.CHARACTERS.WOODIE.DESCRIBE.GIFT = 
	{
		GENERIC = "They're just as fun to give as they are to receive.",
		NICE = "Me and Lucy have been real nice at our deeds.",
		MODERATE = "Me and Lucy have been moderate at our deeds.",
		NAUGHTY = "Me and Lucy have been real naughty at our deeds.",
	}
STRINGS.CHARACTERS.WAXWELL.DESCRIBE.GIFT = 
	{
		GENERIC = "An elegantly wrapped social obligation.",
		NICE = "Hopefully it's worth my efforts.",
		MODERATE = "It could be worse.",
		NAUGHTY = "I deserve that, don't I?",
	}
STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.GIFT = 
	{
		GENERIC = "A gift! From... the gods?",
		NICE = "My deeds have not gone unrewarded!",
		MODERATE = "My performance has lacked a certain something.",
		NAUGHTY = "The gods have my humble apologies for my evil ways.",
	}
STRINGS.CHARACTERS.WEBBER.DESCRIBE.GIFT = 
	{
		GENERIC = "Oh! What is it?!",
		NICE = "We've been very good.",
		MODERATE = "We've been very good... we think.",
		NAUGHTY = "We've been naughty... Sorry.",
	}
STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.GIFT = 
	{
		GENERIC = "Give to friends!",
		NICE = "Very nice to friends",
		MODERATE = "Nice to friends",
		NAUGHTY = "Bad to friends...",
	}
STRINGS.CHARACTERS.WAGSTAFF.DESCRIBE.GIFT = 
	{
		GENERIC = "I seem to have forgotten what's inside. Opening should make it all the more fun.",
		NICE = "My actions have been on the nice side.",
		MODERATE = "My actions have been mostly on the nice side.",
		NAUGHTY = "My actions have been on the naughty side.",
	}
STRINGS.CHARACTERS.WALANI.DESCRIBE.GIFT = 
	{
		GENERIC = "For me? You shouldn't have!",
		NICE = "I've been surfing the good waves this year.",
		MODERATE = "I could've been a lot worse this year.",
		NAUGHTY = "I've been bad to the bone.",
	}
STRINGS.CHARACTERS.WARLY.DESCRIBE.GIFT = 
	{
		GENERIC = "Pour moi?",
		NICE = "I've been a good chef.",
		MODERATE = "I've been a mediocre chef.",
		NAUGHTY = "I've been a naughty chef.",
	}
STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.GIFT = 
	{
		GENERIC = "For ol' Woodlegs?",
		NICE = "Me pirating ways hav' been on the nicest side.",
		MODERATE = "Me pirating ways hav' been on the nicer side.",
		NAUGHTY = "Me pirating ways hav' been on the bad side.",
	}
STRINGS.CHARACTERS.WILBA.DESCRIBE.GIFT = 
	{
		GENERIC = "WILBA WRAPPD'ED IT HERSELF",
		NICE = "WILBA HATH BEEN VERY NICE",
		MODERATE = "WILBA HATH BEEN GOOD",
		NAUGHTY = "WILBA HATH BEEN NAUGHTY...",
	}
STRINGS.CHARACTERS.WHEELER.DESCRIBE.GIFT = 
	{
		GENERIC = "I hope it's a new air balloon!",
		NICE = "I got on the good list!",
		MODERATE = "I didn't even know there was a moderate list.",
		NAUGHTY = "I got on the bad list...",
	}
STRINGS.CHARACTERS.WARBUCKS.DESCRIBE.GIFT = 
	{
		GENERIC = "Ah, a lovely wrap.",
		NICE = "I say, my good deeds have not gone unseen.",
		MODERATE = "I have been rather good this year.",
		NAUGHTY = "I say, I must venture to be nicer next time.",
	}

STRINGS.NAMES.GIFTWRAP = "Gift Wrap"
STRINGS.RECIPE_DESC.GIFTWRAP = "Wrap things up, nice and pretty!"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.GIFTWRAP 		= 	"That's a wrap!"
STRINGS.CHARACTERS.WILLOW.DESCRIBE.GIFTWRAP 		=	"Ribbons burn real good!"
STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.GIFTWRAP 		=	"Wolfgang needs help trying little bow."
STRINGS.CHARACTERS.WENDY.DESCRIBE.GIFTWRAP 			=	"Abby... how do I make the ribbon curly?"
STRINGS.CHARACTERS.WX78.DESCRIBE.GIFTWRAP  			=	"I AM THE SUPERIOR GIFT GIVER"
STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.GIFTWRAP	=	"Wrapping presents is soothing work, isn't it?"
STRINGS.CHARACTERS.WOODIE.DESCRIBE.GIFTWRAP  		=	"Should we do something nice today, Lucy?"
STRINGS.CHARACTERS.WAXWELL.DESCRIBE.GIFTWRAP  		=	"For wrapping odds and ends..."
STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.GIFTWRAP 	=	"I have nay one to show mine wrapping skills!"
STRINGS.CHARACTERS.WEBBER.DESCRIBE.GIFTWRAP  		=	"We'll give each other gifts!"
STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.GIFTWRAP  		=	"Funy wrapping time!"
STRINGS.CHARACTERS.WAGSTAFF.DESCRIBE.GIFTWRAP 		=	"A festive wrapping paper."
STRINGS.CHARACTERS.WALANI.DESCRIBE.GIFTWRAP  		=	"I miss the holidays with my little brother..."
STRINGS.CHARACTERS.WARLY.DESCRIBE.GIFTWRAP  		=	"Lovely, non?"
STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.GIFTWRAP  		=	"It be a lovely gesture, aye."
STRINGS.CHARACTERS.WILBA.DESCRIBE.GIFTWRAP 			=	"WILBA SHALL GIVETH MAMA THE BEST-EST GIFT!"
STRINGS.CHARACTERS.WHEELER.DESCRIBE.GIFTWRAP  		=	"Who am I gonna give presents to out here?"
STRINGS.CHARACTERS.WARBUCKS.DESCRIBE.GIFTWRAP 		=	"The festivities are always a nice change of pace."