local SledBrain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
    self.isMoving = false
end)

function SledBrain:OnStart()
    local root = PriorityNode({
        SequenceNode({
            ActionNode(function() 
				if not self.isMoving then
					self.inst:PushEvent("start_movement")
					self.isMoving = true
				end
            end),
			WaitNode(4),
			ActionNode(function() 
				if self.inst.spawnedin == true then
					self.inst:PushEvent("stop_movement")
				end
			end),
        }),
    })
    self.bt = BT(self.inst, root)
end

return SledBrain