local giant_loot1 =
{
    "deerclops_eyeball",
    "dragon_scales",
    "mandrake",
	"walrus_tusk",
}

local giant_loot2 =
{
    "science_blueprint",
    "magic_blueprint",
	"blueprint",
    "bundlewrap_blueprint",
}

local giant_loot3 =
{
    "bearger_fur",
    "goose_feather",
    "spiderhat",
    "steelwool",
	"minotaurhorn",
}

local all_loot =
{
    "bearger_fur",
    "goose_feather",
    "spiderhat",
    "steelwool",
	"minotaurhorn",
    "bundlewrap_blueprint",
    "deerclops_eyeball",
	"dragon_scales",
    "mandrake",
	"walrus_tusk",
}

local gem_loot =
{
	"greengem",
	"yellowgem",
	"orangegem",
	"purplegem",
}

local function FillItems(items, prefab)
    for i = 1 + #items, math.random(3, 4) do
        table.insert(items, prefab)
    end
end

local GiftShowerLoot = Class(function(self, inst)
    self.inst = inst
end)

function GiftShowerLoot:NaughtyGiftLoot()
	local items = {}
    table.insert(items, math.random() < .5 and "spider" or "spider_warrior")
    FillItems(items, "spoiled_food")
    table.insert(self.loot, items)

	items = {
		{"killerbee", 2},
	}
    table.insert(items, "trinket_4")
    table.insert(self.loot, items)

	items = {}
    FillItems(items, "charcoal")
    table.insert(self.loot, items)
end

function GiftShowerLoot:ModerateGiftLoot()
	local items = {}
    table.insert(items, math.random() < .5 and "redgem" or "bluegem")
    table.insert(items, "goldnugget")
    FillItems(items, "charcoal")
    table.insert(self.loot, items)

	items = {}
	table.insert(items, math.random() < .5 and "bluegem" or "redgem")
    table.insert(items, "goldnugget")
    FillItems(items, "charcoal")
    table.insert(self.loot, items)

	if math.random() < .4 then
		items = {
			"goatmilk",
			{"pumpkincookie", math.random(2,3)},
		}
		table.insert(self.loot, items)
	end

	items = {}
    if math.random() < .03 then
        table.insert(items, "krampus_sack")
	elseif not GetPlayer().components.builder:KnowsRecipe("giftwrap") then
		table.insert(items, "giftwrap_blueprint")
	else
		table.insert(items, all_loot[math.random(#all_loot)])
    end
    table.insert(items, "goldnugget")
    FillItems(items, "charcoal")
    table.insert(self.loot, items)
end

function GiftShowerLoot:NiceGiftLoot()
	local items = {}
    table.insert(items, gem_loot[math.random(#gem_loot)])
    table.insert(items, "thulecite")
    FillItems(items, "goldnugget")
    table.insert(self.loot, items)
	
	items = {}
	table.insert(items, gem_loot[math.random(#gem_loot)])
    table.insert(items, "thulecite")
    FillItems(items, "goldnugget")
    table.insert(self.loot, items)

	items = {
		"goatmilk",
		{"pumpkincookie", math.random(2,3)},
	}
	table.insert(self.loot, items)

	items = {}
    if math.random() < .1 then
        table.insert(items, "krampus_sack")
	elseif not GetPlayer().components.builder:KnowsRecipe("giftwrap") then
		table.insert(items, "giftwrap_blueprint")
    end
    table.insert(items, gem_loot[math.random(#gem_loot)])
    FillItems(items, "goldnugget")
    table.insert(self.loot, items)
	
    items = {}
    local i1 = math.random(#giant_loot3)
    local i2 = math.random(#giant_loot3 - 1)
    table.insert(items, giant_loot1[math.random(#giant_loot1)])
    if math.random() < .5 then
        table.insert(items, giant_loot2[math.random(#giant_loot2)])
    end
    table.insert(items, giant_loot3[i1])
    table.insert(items, giant_loot3[i2 == i1 and #giant_loot3 or i2])
    table.insert(self.loot, items)
end

function GiftShowerLoot:RollGiftLoot()
    self.loot = {}
	local player = GetPlayer()

    if player and player.components and player.components.kramped then
        local kramped = player.components.kramped

        if kramped.actions >= 15 or kramped.krampuscame == true then
			print("You've been naughty!")
            self:NaughtyGiftLoot()
			self:SetStatus("naughty")
			kramped.krampuscame = false
        elseif kramped.actions >= 5 then
			print("You've been moderately nice.")
            self:ModerateGiftLoot()
			self:SetStatus("moderate")
        else
			print("You've been nice!")
            self:NiceGiftLoot()
			self:SetStatus("nice")
        end
    end
end

function GiftShowerLoot:GetLoot()
    local loot = {}

    self:RollGiftLoot()

    for i, v in ipairs(self.loot) do
        table.insert(loot, v)
    end

    return loot
end

function GiftShowerLoot:SetStatus(status)
	self.status = status
end

function GiftShowerLoot:GetStatus()
	return self.status
end

function GiftShowerLoot:NilifyLoot()
	self.loot = {}
end

function GiftShowerLoot:OnSave()
    return
    {
        loot = self.loot,
    }
end

function GiftShowerLoot:OnLoad(data)
	if data ~= nil then
        self.loot = data.loot
	end
end

return GiftShowerLoot