local assets =
{
    Asset("ANIM", "anim/sled.zip"),
}

local function JingleSound(inst)    
    inst.SoundEmitter:PlaySound("dontstarve/sled/bell2")
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
	inst.entity:AddPhysics()
	inst.entity:AddSoundEmitter()

    inst.Physics:SetMass(1)
    inst.Physics:SetCapsule(1, 1)
    inst.Physics:SetFriction(0)
    inst.Physics:SetDamping(5)
    inst.Physics:SetCollisionGroup(COLLISION.CHARACTERS)
    inst.Physics:ClearCollisionMask()
	inst.Physics:CollidesWith(COLLISION.GROUND)

	inst.AnimState:SetOrientation( ANIM_ORIENTATION.OnGround )
	inst.AnimState:SetLayer( LAYER_BACKGROUND )
	inst.AnimState:SetSortOrder( 1 )	
	inst.AnimState:SetMultColour(1, 1, 1, .4)

	inst.Transform:SetScale(1.8,1.8,1.8)

	inst.persists = false
	inst.spawnedin = true

    inst:AddTag("sled")
	inst:AddTag("shelter")
	inst:AddTag("dryshelter")
	inst:AddTag("NOCLICK")
	inst:AddTag("NOBLOCK")
	inst:AddTag("FX")

    inst.AnimState:SetBank("sled")
    inst.AnimState:SetBuild("sled")
    inst.AnimState:PlayAnimation("idle")

	if IsDLCEnabledAndInstalled(PORKLAND_DLC) or IsDLCEnabledAndInstalled(CAPY_DLC) or IsDLCEnabledAndInstalled(REIGN_OF_GIANTS) then
		inst:AddComponent("sizetweener")
	end

	inst:AddComponent("locomotor")
	inst.components.locomotor.runspeed = 5

	local brain = require "brains/sledbrain"
	inst:SetBrain(brain)

	inst:SetStateGraph("SGsled")

	inst:ListenForEvent("start_movement", function()
		local current = Vector3(inst.Transform:GetWorldPosition())
		local direction = (Vector3(GetPlayer().Transform:GetWorldPosition()) - current):GetNormalized()
		local angle = math.acos(direction:Dot(Vector3(1, 0, 0) ) ) / DEGREES
		inst.Transform:SetRotation(angle)
		inst:FacePoint(Vector3(GetPlayer().Transform:GetWorldPosition()))
	end)

--	inst.jingle_task = inst:DoPeriodicTask(math.random(1,1.5), function () JingleSound(inst) end)

	JingleSound(inst)

    return inst
end

return Prefab("common/sled", fn, assets)