require("stategraphs/commonstates")

local function OnEnd(inst)
	if inst.jingle_task then
		inst.jingle_task:Cancel()
		inst.jingle_task = nil
	end
	inst:Remove()
end

local actionhandlers = 
{

}

local events =
{
    EventHandler("start_movement", function(inst) inst.sg:GoToState("fly") end),
    EventHandler("stop_movement", function(inst) inst.sg:GoToState("leave") end),
}

local states =
{
	State
    {
        name = "fly",
        tags = {"moving","canrotate"},

        onenter = function(inst)
            inst.components.locomotor:RunForward()
            inst.sg:SetTimeout(1+2*math.random())
            inst.AnimState:PlayAnimation("idle")
        end,
        
        onupdate = function(inst)
        end,

        ontimeout=function(inst)
            inst.sg:GoToState("fly")
        end,
    },     

    State
    {
        name = "leave",
        tags = {"moving","canrotate"},

        onenter = function(inst)
            inst.components.locomotor:RunForward()
			inst.AnimState:PlayAnimation("idle")
			inst.components.sizetweener:StartTween(0, 4, OnEnd)
		--	inst:DoTaskInTime(2, function() inst:Remove() end)
		end,
    }, 
}

return StateGraph("sled", states, events, "fly", actionhandlers)